<?php
	
	function sti_mysql_parse_parameters($query)
	{
		$result = "";
		while (strpos($query, "{") !== false)
		{
			$result .= substr($query, 0, strpos($query, "{"));
			$query = substr($query, strpos($query, "{") + 1);
			$parameter_name = substr($query, 0, strpos($query, "}"));
			$result .= sti_get_parameter($parameter_name);
			$query = substr($query, strpos($query, "}") + 1);
		}
		
		return $result.$query;
	}
	
	function sti_mysql_parse_connection_string($connection_string)
	{
		class connection_info {
			var $host;
			var $port = "3306";
			var $database;
			var $user_id;
			var $password;
			var $charset = "utf8";
		}

		$info = new connection_info;
		$parameters = split(";", $connection_string);
		foreach($parameters as $parameter)
		{
			$parts = split("=", $parameter);
			$name = $parts[0];
			$value = $parts[1];

			if (isset($value))
			{
				switch (strtolower($name))
				{
					case "server":
					case "host":
					case "location":
						$info->host = $value;
						break;

					case "port":
						$info->port = $value;
						break;

					case "database":
					case "datasource":
					case "data source":
						$info->database = $value;
						break;

					case "uid":
					case "user":
					case "userid":
					case "user id":
						$info->user_id = $value;
						break;

					case "pwd":
					case "password":
						$info->password = $value;
						break;
						
					case "charset":
						$info->charset = $value;
						break;
				}
			}
		}

		return $info;
	}
	
	function sti_mysql_get_column_type($fields, $column)
	{
		$column_type = $column->type;
		if (strlen($column->table) > 0)
		{
			foreach ($fields as $field)
			{
				if ($field->table == $column->table && $field->name == $column->name)
				{
					$column_type = $field->type;
					break;
				}
			}
		}
		
		if (strpos($column_type, "(")) $column_type = substr($field->type, 0, strpos($column_type, "("));
		
		switch (strtolower($column_type))
		{
			case "int":
			case "tinyint":
			case "smallint":
			case "mediumint":
			case "bigint":
				return "System.Int32";
			
			case "decimal":
			case "float":
			case "double":
			case "real":
				return "System.Decimal";
				
			case "bit":
				return "System.Boolean";
			
			case "date":
			case "time":
			case "datetime":
			case "timestamp":
			case "year":
				return "System.DateTime";
			
			case "blob":
			case "tinyblob":
			case "mediumblob":
			case "longblob":
			case "binary":
			case "varbinary":
				return "System.Byte[]";
		}
		
		return "System.String";
	}
	
	function sti_mysql_test_connection($connection_string)
	{
		$info = sti_mysql_parse_connection_string($connection_string);
		$link = mysql_connect("$info->host:$info->port", $info->user_id, $info->password) or die("ServerError:Could not connect to host '$info->host'.");
		mysql_close($link);
		
		return "Successfull";
	}
	
	function sti_mysql_get_columns($connection_string, $query)
	{
		$info = sti_mysql_parse_connection_string($connection_string);
		$link = mysql_connect("$info->host:$info->port", $info->user_id, $info->password) or die("ServerError:Could not connect to host '$info->host'.");
		mysql_select_db($info->database, $link) or die("ServerError:Could not find database '$info->database'.");
		$result = mysql_query($query, $link) or die("ServerError:Data not found.");
		
		$res = "";
		
		$columns = Array();
		$tables = Array();
		while ($column = mysql_fetch_field($result))
		{
			array_push($columns, $column);
			if (strlen($column->table) > 0) $tables[$column->table] = $column->table;
		}
		
		$fields = Array();
		foreach ($tables as $table)
		{
			$result = mysql_query("show fields from $table", $link);
			while ($row = mysql_fetch_array($result))
			{
				$field->table = $table;
				$field->name = $row["Field"];
				$field->type = $row["Type"];
				array_push($fields, $field);
				unset($field);
			}
		}
		
		$xml_output = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<Tables>\n  <RetrieveColumns>\n";
		
		foreach ($columns as $column)
		{
			$column_type = sti_mysql_get_column_type($fields, $column);
			$xml_output .= "    <Column table=\"$column->table\" name=\"$column->name\" type=\"$column_type\" />\n";
		}
		
		$xml_output .= "  </RetrieveColumns>\n</Tables>";
		
		mysql_free_result($result);
		mysql_close($link);
		
		return $xml_output;
	}
	
	function sti_mysql_get_data($connection_string, $data_source_name, $query)
	{
		$info = sti_mysql_parse_connection_string($connection_string);
		$link = mysql_connect("$info->host:$info->port", $info->user_id, $info->password) or die("ServerError:Could not connect to host '$info->host'.");
		mysql_set_charset($info->charset, $link);
		mysql_select_db($info->database, $link) or die("ServerError:Could not find database '$info->database'.");
		
		$query = sti_mysql_parse_parameters($query);
		$query_result = mysql_query($query, $link) or die("ServerError:Data not found.");
		
		$columns = Array();
		$tables = Array();
		while ($column = mysql_fetch_field($query_result))
		{
			array_push($columns, $column);
			if (strlen($column->table) > 0) $tables[$column->table] = $column->table;
		}
		
		$fields = Array();
		foreach ($tables as $table)
		{
			$result = mysql_query("show fields from $table", $link);
			while ($row = mysql_fetch_array($result))
			{
				$field->table = $table;
				$field->name = $row["Field"];
				$field->type = $row["Type"];
				array_push($fields, $field);
				unset($field);
			}
		}
		
		$xml_output = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<Database>\n";
		
		while ($row = mysql_fetch_assoc($query_result))
		{
			$xml_output .= "  <$data_source_name>\n";
			foreach ($columns as $column)
			{
				$value = $row[$column->name];

				$column_type = sti_mysql_get_column_type($fields, $column);
				
				if ($column_type == "System.Byte[]") $value = base64_encode($value);
				else
				{
					$value = str_replace("&", "&amp;", $value);
					$value = str_replace("<", "&lt;", $value);
					$value = str_replace(">", "&gt;", $value);
				}
				
				$xml_output .= "    <$column->name>$value</$column->name>\n";
			}
			$xml_output .= "  </$data_source_name>\n";
		}
		
		$xml_output .= "</Database>";
		
		mysql_free_result($result);
		mysql_free_result($query_result);
		mysql_close($link);
		
		return $xml_output;
	}
?>