<?php
	require("localization.php");
	require("database_mssql.php");
	require("database_mysql.php");
	require("database_odbc.php");
	require("database_pg.php");
	require("handler.php");

	
	$report_key = sti_get_parameter("stimulsoft_report_key");
	$client_key = sti_get_parameter("stimulsoft_client_key");
	$client_data = $HTTP_RAW_POST_DATA;
	if (!isset($client_data)) $client_data = file_get_contents("php://input");
	
	
	/**
	 *  Directory, which contains the localization XML files.
	 */
	function sti_get_localization_directory()
	{
		return "localization";
	}
	
	
	/**
	 *  Returns .mrt or .mdc file by string ID that was set when running.
	 *  If necessary, it is possible to change the code for getting a report by its ID from file or from database.
	 */
	function sti_get_report($report_key)
	{
		/*switch ($report_key)
		{
			case "report1": return file_get_contents("/reports/Report.mrt");
			case "report2": return file_get_contents("/reports/Document.mdc");
		}*/
		
		if (file_exists("../reports/$report_key")) return file_get_contents("../reports/$report_key");
		
		// If there is no need to load the report, then the 'null' string will be sent
		return "null";
	}
	
	
	/**
	 *  Saving a report.
	 *  Response to the client - error code. Standard codes:
	 *      -1: the message box is not shown
	 *       0: shows the "Report is successfully saved" message
	 *  In other cases shows a window with the defined value
	 */
	function sti_save_report($report)
	{
		// The code for saving a report can be placed here
		
		return "-1";
	}
	
	
	/**
	 *  The function for changing values on parameters by their name in the SQL query.
	 *  Parameters can be set as {ParamName} in the SQL query.
	 *  By default values are taken according to the name of a parameter in the URL string.
	 */
	function sti_get_parameter($parameter_name, $default_value = "")
	{
		/*switch ($parameter_name)
		{
			case "ParameterName1": return "Value1";
			case "ParameterName2": return "Value2";
		}*/
		
		if(isset($_POST[$parameter_name])) $parameter_value = sti_strip($_POST[$parameter_name]);
		else if(isset($_GET[$parameter_name])) $parameter_value = sti_strip($_GET[$parameter_name]);
		else $parameter_value = $default_value;
		
		return $parameter_value;
	}
	
	
	/**
	 *  Getting the Connection String when requesting the client's Flash application to a database.
	 *  In this function you can change the Connection String of a report.
	 */
	function sti_get_connection_string($connection_type, $connection_string)
	{
		/*switch ($connection_type)
		{
			case "StiSqlDatabase": return "Data Source=SERVER\SQLEXPRESS;Initial Catalog=master;Integrated Security=True";
			case "StiMySqlDatabase": return "Server=localhost;Database=db_name;Port=3306;User=root;Password=;";
			case "StiOdbcDatabase": return "DSN=MS Access Database;DBQ=D:\NWIND.MDB;DefaultDir=D:;DriverId=281;FIL=MS Access;MaxBufferSize=2048;PageTimeout=5;UID=admin;";
			case "StiPostgreSQLDatabase": return "Server=localhost;Database=db_name;Port=5432;User=postgres;Password=postgres;";
		}*/
		
		return $connection_string;
	}
	
	
	
	
	// Processing client Flash application commands
	if (isset($client_key)) echo sti_client_event_handler($client_key, $report_key, $client_data);
	
?>